Index: qrda/C0Q/trunk/kids/C0Q-1_SEQ-003_PAT-003.KID
===================================================================
--- qrda/C0Q/trunk/kids/C0Q-1_SEQ-003_PAT-003.KID	(revision 1508)
+++ qrda/C0Q/trunk/kids/C0Q-1_SEQ-003_PAT-003.KID	(revision 1510)
@@ -1,3 +1,3 @@
-KIDS Distribution saved on Aug 03, 2012@17:09:59
+KIDS Distribution saved on Aug 06, 2012@11:32:48
 QUALITY MEASURES 1.0 PATCH 3
 **KIDS**:C0Q*1.0*3^
@@ -6,5 +6,5 @@
 C0Q*1.0*3
 "BLD",7936,0)
-C0Q*1.0*3^QUALITY MEASURES^0^3120803^y
+C0Q*1.0*3^QUALITY MEASURES^0^3120806^y
 "BLD",7936,1,0)
 ^^155^155^3120803^
@@ -328,5 +328,5 @@
 
 "BLD",7936,6.3)
-11
+12
 "BLD",7936,"ABPKG")
 n
@@ -441,6 +441,4 @@
 "DATA",1130580001.101,4,6,3,0)
 using a certified/qualified electronic health record (EHR)
-"DATA",1130580001.101,4,7)
-^^^^
 "DATA",1130580001.101,6,0)
 PQRI MEASURE 47^^^2.16.840.1.113883.3.249.11.52
@@ -463,6 +461,4 @@
 "DATA",1130580001.101,6,6,5,0)
 or provide an advance care plan.
-"DATA",1130580001.101,6,7)
-^^^^
 "DATA",1130580001.101,7,0)
 PQRI MEASURE 48^^^2.16.840.1.113883.3.249.11.53
@@ -481,6 +477,4 @@
 "DATA",1130580001.101,7,6,3,0)
 absence of urinary incontinence within 12 months
-"DATA",1130580001.101,7,7)
-^^^^
 "DATA",1130580001.101,12,0)
 MU EP NQF 0043^^^2.16.840.1.113883.3.249.11.8
@@ -515,6 +509,4 @@
 "DATA",1130580001.101,14,6,3,0)
 within 12 months before the end of the measurement period
-"DATA",1130580001.101,14,7)
-^^^^
 "DATA",1130580001.101,16,0)
 PQRI MEASURE 173^^^2.16.840.1.113883.3.249.11.55
@@ -531,8 +523,6 @@
 "DATA",1130580001.101,16,6,2,0)
 ed for unhealthy alcohol use using a systematic method within 24 months
-"DATA",1130580001.101,16,7)
-^^^^
 "DATA",1130580001.101,23,0)
-MU HOS NQF 0495^^
+MU HOS NQF 0495
 "DATA",1130580001.101,23,1)
 ED THROUGHPUT ARRIVAL TO DEPARTURE
@@ -550,5 +540,5 @@
 NQF0495^^^^^^88^165
 "DATA",1130580001.101,24,0)
-MU HOS NQF 0497^^
+MU HOS NQF 0497
 "DATA",1130580001.101,24,1)
 ED THROUGHPUT ADMITTING DECISION TO DEPARTURE
@@ -566,5 +556,5 @@
 NQF0497^^^^^^90^168
 "DATA",1130580001.101,25,0)
-MU HOS NQF 0435^^
+MU HOS NQF 0435
 "DATA",1130580001.101,25,1)
 Ischemic stroke.Discharge on anti-thrombotics  
@@ -580,5 +570,5 @@
 NQF0435^^^^^^114^115
 "DATA",1130580001.101,26,0)
-MU HOS NQF 0436^^
+MU HOS NQF 0436
 "DATA",1130580001.101,26,1)
  Ischemic stroke.Anticoagulation for A-fib/flutter
@@ -594,5 +584,5 @@
 NQF0436^^^^^^116^117
 "DATA",1130580001.101,27,0)
-MU HOS NQF 0437^^
+MU HOS NQF 0437
 "DATA",1130580001.101,27,1)
  Ischemic stroke.Thrombolytic therapy for patients arriving within 2 hours of symptom onset
@@ -610,5 +600,5 @@
 NQF0437^^^^^^119^118
 "DATA",1130580001.101,28,0)
-MU HOS NQF 0438^^
+MU HOS NQF 0438
 "DATA",1130580001.101,28,1)
 Ischemic or hemorrhagic stroke.Antithrombotic therapy by day 2
@@ -624,5 +614,5 @@
 NQF0438^^^^^^120^121
 "DATA",1130580001.101,29,0)
-MU HOS NQF 0439^^
+MU HOS NQF 0439
 "DATA",1130580001.101,29,1)
 Ischemic stroke.Discharge on statins
@@ -640,5 +630,5 @@
 NQF0439^^^^^^122^123
 "DATA",1130580001.101,30,0)
-MU HOS NQF 0440^^
+MU HOS NQF 0440
 "DATA",1130580001.101,30,1)
 Ischemic or hemorrhagic stroke.Stroke education
@@ -660,5 +650,5 @@
 NQF0440^^^^^^124^125
 "DATA",1130580001.101,31,0)
-MU HOS NQF 0441^^
+MU HOS NQF 0441
 "DATA",1130580001.101,31,1)
 Ischemic or hemorrhagic stroke.Rehabilitation assessment
@@ -674,5 +664,5 @@
 NQF0441^^^^^^126^127
 "DATA",1130580001.101,32,0)
-MU HOS NQF 0371^^
+MU HOS NQF 0371
 "DATA",1130580001.101,32,1)
 VTE prophylaxis within 24 hours of arrival  
@@ -692,5 +682,5 @@
 NQF0371^^^^^^69^67
 "DATA",1130580001.101,33,0)
-MU HOS NQF 0372^^
+MU HOS NQF 0372
 "DATA",1130580001.101,33,1)
 ICU VTE prophylaxis  
@@ -712,5 +702,5 @@
 NQF0372^^^^^^128^71
 "DATA",1130580001.101,34,0)
-MU HOS NQF 0373^^
+MU HOS NQF 0373
 "DATA",1130580001.101,34,1)
 Anticoagulation overlap therapy  
@@ -738,5 +728,5 @@
 NQF0373^^^^^^129^144
 "DATA",1130580001.101,35,0)
-MU HOS NQF 0374^^
+MU HOS NQF 0374
 "DATA",1130580001.101,35,1)
 Platelet monitoring on unfractionated heparin
@@ -768,5 +758,5 @@
 NQF0374^^^^^^145^146
 "DATA",1130580001.101,36,0)
-MU HOS NQF 0375^^
+MU HOS NQF 0375
 "DATA",1130580001.101,36,1)
 VTE discharge instructions
@@ -800,5 +790,5 @@
 NQF0375^^^^^^147^156
 "DATA",1130580001.101,37,0)
-MU HOS NQF 0376^^
+MU HOS NQF 0376
 "DATA",1130580001.101,37,1)
 Incidence of potentially preventable VTE
@@ -908,5 +898,5 @@
 NQF0041^^^^^^242^243
 "DATA",1130580001.101,43,0)
-MU EP NQF 0024^^
+MU EP NQF 0024
 "DATA",1130580001.101,43,1)
 NQF0024 Weight Assessment and Counseling for Children and Adolescents (ALL)
@@ -968,5 +958,5 @@
 combination rates.
 "DATA",1130580001.101,44,7)
-NQF0038^^^^
+NQF0038
 "DATA",1130580001.101,45,0)
 MU EP NQF 0059^^^2.16.840.1.113883.3.249.11.2
@@ -1036,5 +1026,5 @@
 prescribed ACE inhibitor or ARB therapy
 "DATA",1130580001.101,48,7)
-NQF0081^^^^
+NQF0081
 "DATA",1130580001.101,49,0)
 MU EP NQF 0070^^^2.16.840.1.113883.3.249.11.6
@@ -1070,5 +1060,5 @@
 mammogram to screen for breast cancer
 "DATA",1130580001.101,50,7)
-NQF0031^^^^
+NQF0031
 "DATA",1130580001.101,51,0)
 MU EP NQF 0034^^^2.16.840.1.113883.3.249.11.10
@@ -1086,7 +1076,7 @@
 colorectal cancer.
 "DATA",1130580001.101,51,7)
-NQF0034^^^^
+NQF0034
 "DATA",1130580001.101,52,0)
-MU EP NQF 0067^^
+MU EP NQF 0067
 "DATA",1130580001.101,52,1)
 Coronary Artery Disease (CAD): Oral Antiplatelet Therapy Prescribed for Patients with CAD 
@@ -1100,7 +1090,7 @@
 diagnosis of CAD who were prescribed oral antiplatelet therapy.
 "DATA",1130580001.101,52,7)
-NQF0067^^^^
+NQF0067
 "DATA",1130580001.101,53,0)
-MU EP NQF 0083^^
+MU EP NQF 0083
 "DATA",1130580001.101,53,1)
 Heart Failure (HF): Beta-Blocker Therapy for Left Ventricular Systolic Dysfunction (LVSD) 
@@ -1116,7 +1106,7 @@
 prescribed beta-blocker therapy
 "DATA",1130580001.101,53,7)
-NQF0083^^^^
+NQF0083
 "DATA",1130580001.101,54,0)
-MU EP NQF 0105^^
+MU EP NQF 0105
 "DATA",1130580001.101,54,1)
 Anti-depressant medication management:  (a) Effective Acute Phase Treatment,(b)Effective Continuation Phase Treatment  
@@ -1134,7 +1124,7 @@
 antidepressant medication treatment.
 "DATA",1130580001.101,54,7)
-NQF0105^^^^
+NQF0105
 "DATA",1130580001.101,55,0)
-MU EP NQF 0086^^
+MU EP NQF 0086
 "DATA",1130580001.101,55,1)
 Primary Open Angle Glaucoma (POAG): Optic Nerve Evaluation
@@ -1152,7 +1142,7 @@
 visits within 12 months.
 "DATA",1130580001.101,55,7)
-NQF0086^^^^
+NQF0086
 "DATA",1130580001.101,56,0)
-MU EP NQF 0088^^
+MU EP NQF 0088
 "DATA",1130580001.101,56,1)
 Diabetic Retinopathy: Documentation of Presence or Absence of Macular Edema and Level of Severity of Retinopathy 
@@ -1172,7 +1162,7 @@
 one or more office visits within 12 months.
 "DATA",1130580001.101,56,7)
-NQF0088^^^^
+NQF0088
 "DATA",1130580001.101,57,0)
-MU EP NQF 0089^^
+MU EP NQF 0089
 "DATA",1130580001.101,57,1)
 Diabetic Retinopathy: Communication with the Physician Managing Ongoing Diabetes Care 
@@ -1194,7 +1184,7 @@
 within 12 months.
 "DATA",1130580001.101,57,7)
-NQF0089^^^^
+NQF0089
 "DATA",1130580001.101,58,0)
-MU EP NQF 0047^^
+MU EP NQF 0047
 "DATA",1130580001.101,58,1)
 Asthma Pharmacologic Therapy
@@ -1212,7 +1202,7 @@
 corticosteroid) or an acceptable alternative treatment
 "DATA",1130580001.101,58,7)
-NQF0047^^^^
+NQF0047
 "DATA",1130580001.101,59,0)
-MU EP NQF 0001^^
+MU EP NQF 0001
 "DATA",1130580001.101,59,1)
 Asthma Assessment
@@ -1232,7 +1222,7 @@
 symptoms.
 "DATA",1130580001.101,59,7)
-NQF0001^^^^
+NQF0001
 "DATA",1130580001.101,60,0)
-MU EP NQF 0002^^
+MU EP NQF 0002
 "DATA",1130580001.101,60,1)
 Oncology Breast Cancer: Hormonal Therapy for Stage IC-IIIC Estrogen Receptor/Progesterone Receptor (ER/PR) Positive Breat Cancer 
@@ -1250,7 +1240,7 @@
 reporting period.
 "DATA",1130580001.101,60,7)
-NQF0002^^^^
+NQF0002
 "DATA",1130580001.101,61,0)
-MU EP NQF 0385^^
+MU EP NQF 0385
 "DATA",1130580001.101,61,1)
 Oncology Colon Cancer: Chemotherapy for Stage III Colon Cancer Patients 
@@ -1268,7 +1258,7 @@
 received adjuvant chemotherapy within the 12-month reporting period
 "DATA",1130580001.101,61,7)
-NQF0385^^^^
+NQF0385
 "DATA",1130580001.101,62,0)
-MU EP NQF 0389^^
+MU EP NQF 0389
 "DATA",1130580001.101,62,1)
 Prostate Cancer: Avoidance of Overuse of Bone Scan for Staging Low Risk Prostate Cancer Patients 
@@ -1288,7 +1278,7 @@
 any time since diagnosis of prostate cancer.
 "DATA",1130580001.101,62,7)
-NQF0389^^^^
+NQF0389
 "DATA",1130580001.101,63,0)
-MU EP NQF 0027^^
+MU EP NQF 0027
 "DATA",1130580001.101,63,1)
 Smoking Smokers and Tobacco Users to Quit,b. Discussing Smoking and Tobacco use Cessation Medications, c. Discussing Smoking and Tobacco use Cessation Strategies and Tobacco Use Cessation, Medical assistance: a. Advising 
@@ -1308,7 +1298,7 @@
 cessation medications, methods or strategies
 "DATA",1130580001.101,63,7)
-NQF0027^^^^
+NQF0027
 "DATA",1130580001.101,64,0)
-MU EP NQF 0055^^
+MU EP NQF 0055
 "DATA",1130580001.101,64,1)
 Diabetes: Eye Exam
@@ -1324,7 +1314,7 @@
 exam (no evidence of retinopathy) by an eye care professional
 "DATA",1130580001.101,64,7)
-NQF0055^^^^
+NQF0055
 "DATA",1130580001.101,65,0)
-MU EP NQF 0062^^
+MU EP NQF 0062
 "DATA",1130580001.101,65,1)
 Diabetes: Urine Screening
@@ -1340,7 +1330,7 @@
 nephropathy.
 "DATA",1130580001.101,65,7)
-NQF0062^^^^
+NQF0062
 "DATA",1130580001.101,66,0)
-MU EP NQF 0056^^
+MU EP NQF 0056
 "DATA",1130580001.101,66,1)
 Diabetes:  Foot Exam
@@ -1356,7 +1346,7 @@
 with monofilament, or pulse exam).
 "DATA",1130580001.101,66,7)
-NQF0056^^^^
+NQF0056
 "DATA",1130580001.101,67,0)
-MU EP NQF 0074^^
+MU EP NQF 0074
 "DATA",1130580001.101,67,1)
 Coronary Artery Disease (CAD): Drug Therapy for Lowering LDLCholesterol
@@ -1372,7 +1362,7 @@
 on current ACC/AHA guidelines).
 "DATA",1130580001.101,67,7)
-NQF0074^^^^
+NQF0074
 "DATA",1130580001.101,68,0)
-MU EP NQF 0084^^
+MU EP NQF 0084
 "DATA",1130580001.101,68,1)
 Heart Failure (HF): Warfarin Therapy Patients with Atrial Fibrillation
@@ -1388,7 +1378,7 @@
 who were prescribed warfarin therapy.
 "DATA",1130580001.101,68,7)
-NQF0084^^^^
+NQF0084
 "DATA",1130580001.101,69,0)
-MU EP NQF 0073^^
+MU EP NQF 0073
 "DATA",1130580001.101,69,1)
 Ischemic Vascular Disease (IVD):  Blood Pressure Management
@@ -1420,7 +1410,7 @@
 (<140/90 mmHg).
 "DATA",1130580001.101,69,7)
-NQF0073^^^^
+NQF0073
 "DATA",1130580001.101,70,0)
-MU EP NQF 0068^^
+MU EP NQF 0068
 "DATA",1130580001.101,70,1)
 Ischemic Vascular Disease (IVD):  Use of Aspirin or Another Antithrombotic 
@@ -1446,7 +1436,7 @@
 another antithrombotic during the measurement year
 "DATA",1130580001.101,70,7)
-NQF0068^^^^
+NQF0068
 "DATA",1130580001.101,71,0)
-MU EP NQF 0004^^
+MU EP NQF 0004
 "DATA",1130580001.101,71,1)
  Initiation and Engagement of Alcohol and Other Drug  Dependence Treatment:(a)Initiation,(b)Engagement 
@@ -1468,7 +1458,7 @@
 services with an AOD diagnosis within 30 days of the initiation visit.
 "DATA",1130580001.101,71,7)
-NQF0004^^^^
+NQF0004
 "DATA",1130580001.101,72,0)
-MU EP NQF 0012^^
+MU EP NQF 0012
 "DATA",1130580001.101,72,1)
 Prenatal Care:  Screening for Human Immunodeficiency Virus (HIV)
@@ -1484,7 +1474,7 @@
 second prenatal care visit.
 "DATA",1130580001.101,72,7)
-NQF0012^^^^
+NQF0012
 "DATA",1130580001.101,73,0)
-MU EP NQF 0014^^
+MU EP NQF 0014
 "DATA",1130580001.101,73,1)
 Prenatal Care:  Anti-D Immune Globulin
@@ -1500,7 +1490,7 @@
 immune globulin at 26-30 weeks gestation.
 "DATA",1130580001.101,73,7)
-NQD0014^^^^
+NQD0014
 "DATA",1130580001.101,74,0)
-MU EP NQF 0018^^
+MU EP NQF 0018
 "DATA",1130580001.101,74,1)
 Controlling High Blood Pressure
@@ -1516,7 +1506,7 @@
 the measurement year 
 "DATA",1130580001.101,74,7)
-NQF0018^^^^
+NQF0018
 "DATA",1130580001.101,75,0)
-MU EP NQF 0032^^
+MU EP NQF 0032
 "DATA",1130580001.101,75,1)
 Cervical Cancer Screening
@@ -1530,7 +1520,7 @@
 more Pap tests to screen for cervical cancer
 "DATA",1130580001.101,75,7)
-NQF0032^^^^
+NQF0032
 "DATA",1130580001.101,76,0)
-MU EP NQF 0033^^
+MU EP NQF 0033
 "DATA",1130580001.101,76,1)
 Chlamydia Screening for Women
@@ -1546,7 +1536,7 @@
 year.
 "DATA",1130580001.101,76,7)
-NQF0033^^^^
+NQF0033
 "DATA",1130580001.101,77,0)
-MU EP NQF 0036^^
+MU EP NQF 0036
 "DATA",1130580001.101,77,1)
 Use of Appropriate Medications for Asthma
@@ -1564,7 +1554,7 @@
 years, and total). 
 "DATA",1130580001.101,77,7)
-NQF0036^^^^
+NQF0036
 "DATA",1130580001.101,78,0)
-MU EP NQF 0052^^
+MU EP NQF 0052
 "DATA",1130580001.101,78,1)
 Low Back Pain: Use of Imaging Studies
@@ -1580,7 +1570,7 @@
 days of diagnosis.
 "DATA",1130580001.101,78,7)
-NQF0052^^^^
+NQF0052
 "DATA",1130580001.101,79,0)
-MU EP NQF 0075^^
+MU EP NQF 0075
 "DATA",1130580001.101,79,1)
 Ischemic Vascular Disease (IVD): Complete Lipid Panel and LDL Control 
@@ -1604,7 +1594,7 @@
 performed during the measurement year and whose LDL-C<100 mg/dL
 "DATA",1130580001.101,79,7)
-NQF0075^^^^
+NQF0075
 "DATA",1130580001.101,80,0)
-MU EP NQF 0575^^
+MU EP NQF 0575
 "DATA",1130580001.101,80,1)
 Diabetes:  Hemoglobin A1c Control (<8.0%)
@@ -1618,7 +1608,7 @@
 (type 1 or type 2) who had hemoglobin A1c <8.0%
 "DATA",1130580001.101,80,7)
-NQF0575^^^^
+NQF0575
 "DATA",1130580001.101,81,0)
-MU EP NQF 0028B^^
+MU EP NQF 0028B
 "DATA",1130580001.101,81,1)
 NQF0028B Preventive Care and Screening  Measure Pair: a. Tobacco Use Assessment,b. Tobacco Cessation Intervention 
@@ -1666,5 +1656,5 @@
 NQF0024 2-10Y^^^^^^334^338
 "DATA",1130580001.101,83,0)
-MU EP NQF 0038 NUM1 DPT^^
+MU EP NQF 0038 NUM1 DPT
 "DATA",1130580001.101,83,5)
 NQF0038 NUM1 DPT
@@ -1672,5 +1662,5 @@
 NQF0038 NUM1 DPT^^^^^^329^192^11
 "DATA",1130580001.101,84,0)
-MU EP NQF 0038 NUM2 IPV^^
+MU EP NQF 0038 NUM2 IPV
 "DATA",1130580001.101,84,5)
 NQF0038 NUM2 IPV
@@ -1678,5 +1668,5 @@
 NQF0038 NUM2 IPV^^^^^^224^192^11
 "DATA",1130580001.101,85,0)
-MU EP NQF 0038 NUM3 MMR^^
+MU EP NQF 0038 NUM3 MMR
 "DATA",1130580001.101,85,5)
 NQF0038 NUM3 MMR
@@ -1684,5 +1674,5 @@
 NQF0038 NUM3 MMR^^^^^^183^192^11
 "DATA",1130580001.101,86,0)
-MU EP NQF 0038 NUM4 HiB^^
+MU EP NQF 0038 NUM4 HiB
 "DATA",1130580001.101,86,5)
 NQF0038 NUM4 HiB
@@ -1690,5 +1680,5 @@
 NQF0038 NUM4 HiB^^^^^^189^192^11
 "DATA",1130580001.101,87,0)
-MU EP NQF 0038 NUM5 HEP B^^
+MU EP NQF 0038 NUM5 HEP B
 "DATA",1130580001.101,87,5)
 NQF0038 NUM5 HEP B
@@ -1696,5 +1686,5 @@
 NQF0038 NUM5 HEP B^^^^^^194^192^11
 "DATA",1130580001.101,88,0)
-MU EP NQF 0038 NUM6 VZV^^
+MU EP NQF 0038 NUM6 VZV
 "DATA",1130580001.101,88,5)
 NQF0038 NUM6 VZV
@@ -1702,5 +1692,5 @@
 NQF0038 NUM6 VZV^^^^^^198^192^11
 "DATA",1130580001.101,89,0)
-MU EP NQF 0038 NUM7 PCV^^
+MU EP NQF 0038 NUM7 PCV
 "DATA",1130580001.101,89,5)
 NQF0038 NUM7 PCV
@@ -1708,5 +1698,5 @@
 NQF0038 NUM7 PCV^^^^^^205^192^11
 "DATA",1130580001.101,90,0)
-MU EP NQF 0038 NUM8 HEP A^^
+MU EP NQF 0038 NUM8 HEP A
 "DATA",1130580001.101,90,5)
 NQF0038 NUM8 HEP A
@@ -1714,5 +1704,5 @@
 NQF0038 NUM8 HEP A^^^^^^208^192^11
 "DATA",1130580001.101,91,0)
-MU EP NQF 0038 NUM9 RV^^
+MU EP NQF 0038 NUM9 RV
 "DATA",1130580001.101,91,5)
 NQF0038 NUM9
@@ -1720,5 +1710,5 @@
 NQF0038 NUM9^^^^^^216^192^11
 "DATA",1130580001.101,92,0)
-MU EP NQF 0038 NUM10 FLU^^
+MU EP NQF 0038 NUM10 FLU
 "DATA",1130580001.101,92,5)
 NQF0038 NUM10
@@ -1726,5 +1716,5 @@
 NQF0038 NUM10^^^^^^331^192^11
 "DATA",1130580001.101,93,0)
-MU EP NQF 0038 NUM11 COMBO5^^
+MU EP NQF 0038 NUM11 COMBO5
 "DATA",1130580001.101,93,5)
 NQF0038 NUM11 COMBO5
@@ -1732,5 +1722,5 @@
 NQF0038 NUM11 COMBO5^^^^^^228^192^11
 "DATA",1130580001.101,94,0)
-MU EP NQF 0038 NUM12 COMBO6^^
+MU EP NQF 0038 NUM12 COMBO6
 "DATA",1130580001.101,94,5)
 NQF0038 NUM12 COMBO6
@@ -1738,57 +1728,39 @@
 NQF0038 NUM12 COMBO6^^^^^^231^192^11
 "DATA",1130580001.101,95,0)
-MU 2011 INP ADV DIRECTIVES^^
+MU 2011 INP ADV DIRECTIVES
 "DATA",1130580001.101,95,5)
 Advance Directives
-"DATA",1130580001.101,95,7)
-^^^^
 "DATA",1130580001.101,96,0)
-MU 2011 INP CPOE^^
+MU 2011 INP CPOE
 "DATA",1130580001.101,96,5)
 CPOE for Medications
-"DATA",1130580001.101,96,7)
-^^^^
 "DATA",1130580001.101,97,0)
-MU 2011 INP MED RECON^^
+MU 2011 INP MED RECON
 "DATA",1130580001.101,97,5)
 Medication Reconcilliation
-"DATA",1130580001.101,97,7)
-^^^^
 "DATA",1130580001.101,98,0)
-MU 2011 INP PROBLEM LIST^^
+MU 2011 INP PROBLEM LIST
 "DATA",1130580001.101,98,5)
 Problem List
-"DATA",1130580001.101,98,7)
-^^^^
 "DATA",1130580001.101,99,0)
-MU 2011 INP VITAL SIGNS^^
+MU 2011 INP VITAL SIGNS
 "DATA",1130580001.101,99,5)
 Record Vital Signs
-"DATA",1130580001.101,99,7)
-^^^^
 "DATA",1130580001.101,100,0)
-MU 2011 INP SMOKING STATUS^^
+MU 2011 INP SMOKING STATUS
 "DATA",1130580001.101,100,5)
 Smoking Status
-"DATA",1130580001.101,100,7)
-^^^^
 "DATA",1130580001.101,101,0)
-MU 2011 INP MED LIST^^
+MU 2011 INP MED LIST
 "DATA",1130580001.101,101,5)
 Active Medication List
-"DATA",1130580001.101,101,7)
-^^^^
 "DATA",1130580001.101,102,0)
-MU 2011 INP ALLERGY LIST^^
+MU 2011 INP ALLERGY LIST
 "DATA",1130580001.101,102,5)
 Medication Allergy List
-"DATA",1130580001.101,102,7)
-^^^^
 "DATA",1130580001.101,103,0)
-MU 2011 INP DEMOGRAPHICS^^
+MU 2011 INP DEMOGRAPHICS
 "DATA",1130580001.101,103,5)
 Record Demographics
-"DATA",1130580001.101,103,7)
-^^^^
 "DATA",1130580001.101,104,0)
 MU EP NQF 0024 11-17Y
@@ -2545,4 +2517,16 @@
 "FRV1K",1130580001.101,"94,7",9,1)
 MU NQF0038 CHILDREN'S IMMUNIZATIONS
+"IX",1130580001.101,1130580001.101,"B",0)
+1130580001.101^B^New-Style B Index. Will be used as part of the key.^R^^F^IR^I^1130580001.101^^^^^LS
+"IX",1130580001.101,1130580001.101,"B",1)
+S ^C0Q(101,"B",$E(X,1,30),DA)=""
+"IX",1130580001.101,1130580001.101,"B",2)
+K ^C0Q(101,"B",$E(X,1,30),DA)
+"IX",1130580001.101,1130580001.101,"B",2.5)
+K ^C0Q(101,"B")
+"IX",1130580001.101,1130580001.101,"B",11.1,0)
+^.114IA^1^1
+"IX",1130580001.101,1130580001.101,"B",11.1,1,0)
+1^F^1130580001.101^.01^30^1^F
 "IX",1130580001.101,1130580001.101,"MU",0)
 1130580001.101^MU^MEANINGFUL USE YEAR KEY^R^^F^IR^I^1130580001.101^^^^^LS
@@ -2557,4 +2541,12 @@
 "IX",1130580001.101,1130580001.101,"MU",11.1,1,0)
 1^F^1130580001.101^.3^30^1^F
+"KEY",1130580001.101,1130580001.101,"A",0)
+1130580001.101^A^P^562
+"KEY",1130580001.101,1130580001.101,"A",2,0)
+^.312IA^1^1
+"KEY",1130580001.101,1130580001.101,"A",2,1,0)
+.01^1130580001.101^1
+"KEYPTR",1130580001.101,1130580001.101,"A")
+1130580001.101^B
 "MBREQ")
 0
@@ -2586,9 +2578,9 @@
 ^9.49I^1^1
 "PKG",215,22,1,0)
-1.0^3120731^3120802^8
+1.0^3120731^3120806^8
 "PKG",215,22,1,"PAH",1,0)
-3^3120803
+3^3120806^8
 "PKG",215,22,1,"PAH",1,1,0)
-^^155^155^3120803
+^^155^155^3120806
 "PKG",215,22,1,"PAH",1,1,1,0)
  Summary
@@ -3002,5 +2994,5 @@
 
 "^DD",1130580001.101,1130580001.101,0,"VRPK")
-QUALITY MEASURES
+C0Q
 "^DD",1130580001.101,1130580001.101,.01,0)
 NAME^RF^^0;1^K:$L(X)>30!($L(X)<1)!'(X'?1P.E) X