Index: ccr/tags/CCD-CCR_GENERATION_UTILITIES_1P2/INSTALL.txt
===================================================================
--- ccr/tags/CCD-CCR_GENERATION_UTILITIES_1P2/INSTALL.txt	(revision 1553)
+++ ccr/tags/CCD-CCR_GENERATION_UTILITIES_1P2/INSTALL.txt	(revision 1559)
@@ -13,6 +13,10 @@
 These URLs are subject to change.
 
-Download the KIDS file to an easily accessible directory.
+Download these KIDS file to an easily accessible directory.
 https://trac.opensourcevista.net/svn/ccr/tags/CCD-CCR_GENERATION_UTILITIES_1P2/CCD-CCR_GENERATION_UTILITIES_1P2.KID
+https://trac.opensourcevista.net/svn/ccr/tags/CCD-CCR_GENERATION_UTILITIES_1P2/C0CRXN_DEF_0002.kids
+https://trac.opensourcevista.net/svn/ccr/tags/CCD-CCR_GENERATION_UTILITIES_1P2/C0CRXN_DATA_072011_0100.gkids.tgz
+
+Don't forget to untar and ungunzip the last file.
 
 Run as a user with XUPROG key, enter the KIDS menu (XPD MAIN MENU) and choose
@@ -20,5 +24,5 @@
 options 2, 3, 4, and 5 if you need to.
 
-When running the installation, you will see this error:
+When running the installation, you will see this error for the first build
 
 '''
@@ -1089,2 +1093,152 @@
  NO Install Message sent 
 
+--------------------------------
+
+Select Installation Option: 1  Load a Distribution
+Enter a Host File: C0CRXN_DEF_0002.kids
+
+KIDS Distribution saved on Aug 13, 2011@13:28:22
+Comment: RxNorm Definition, v 0.2
+
+This Distribution contains Transport Globals for the following Package(s):
+Build C0CRXN DEF 0.2 has been loaded before, here is when: 
+      C0CRXN DEF 0.2   Install Completed
+                       was loaded on Apr 09, 2012@11:15:41
+OK to continue with Load? NO// YES
+
+Distribution OK!
+
+Want to Continue with Load? YES// 
+Loading Distribution...
+
+   C0CRXN DEF 0.2
+Use INSTALL NAME: C0CRXN DEF 0.2 to install this Distribution.
+
+
+Select Installation Option: 6  Install Package(s)
+Select INSTALL NAME:    C0CRXN DEF 0.2     Loaded from Distribution     Loaded f
+rom Distribution  10/3/12@14:40:44
+     => RxNorm Definition, v 0.2  ;Created on Aug 13, 2011@13:28:22
+
+This Distribution was loaded on Oct 03, 2012@14:40:44 with header of 
+   RxNorm Definition, v 0.2  ;Created on Aug 13, 2011@13:28:22
+   It consisted of the following Install(s):
+ C0CRXN DEF 0.2
+
+   Checking C0CRXN DEF 0.2 for overlap with VOE 1.0 .. OK
+            No overlap found
+
+
+   Checking C0CRXN DEF 0.2 for overlap with VOE 1.1 .. OK
+            No overlap found
+
+
+   Checking C0CRXN DEF 0.2 for overlap with NO HOME 1.0 .. OK
+            No overlap found
+
+Checking Install for Package C0CRXN DEF 0.2
+
+Install Questions for C0CRXN DEF 0.2
+
+Incoming Files:
+
+
+   176.001   RXNORM CONCEPTS
+Note:  You already have the 'RXNORM CONCEPTS' File.
+
+
+   176.002   RXNORM NDC TO RXCUI
+Note:  You already have the 'RXNORM NDC TO RXCUI' File.
+
+
+   176.003   RXNORM SOURCES
+Note:  You already have the 'RXNORM SOURCES' File.
+
+
+Want KIDS to INHIBIT LOGONs during the install? NO// 
+Want to DISABLE Scheduled Options, Menu Options, and Protocols? NO// 
+
+Enter the Device you want to print the Install messages.
+You can queue the install by enter a 'Q' at the device prompt.
+Enter a '^' to abort the install.
+
+DEVICE: HOME// PHOME  HOME PRINTER
+
+ 
+ Install Started for C0CRXN DEF 0.2 : 
+               Oct 03, 2012@14:40:50
+ 
+Build Distribution Date: Aug 13, 2011
+ 
+ Installing Routines:..
+               Oct 03, 2012@14:40:50
+ 
+ Installing Data Dictionaries: ....
+               Oct 03, 2012@14:40:50
+ 
+ Updating Routine file......
+ 
+ Updating KIDS files.....
+ 
+ C0CRXN DEF 0.2 Installed. 
+               Oct 03, 2012@14:40:50
+ 
+ No link to PACKAGE file
+ 
+ NO Install Message sent 
+
+----------------------------------
+
+Select Installation Option: 1  Load a Distribution
+Enter a Host File: C0CRXN_DATA_072011_0100.gkids
+
+KIDS Distribution saved on Aug 13, 2011@13:29:12
+Comment: RxNorm July 2011 Release
+
+This Distribution contains Transport Globals for the following Package(s):
+   C0CRXN DATA 072011 1.0
+Distribution OK!
+
+This is a Global Distribution. It contains Global(s) that will
+update your system at this time. The following Global(s) will be installed:
+
+^C0CRXN(176.001)Replace
+^C0CRXN(176.002)Replace
+^C0CRXN(176.003)Replace
+
+If you continue with the Load, the Global(s) will be
+Installed at this time.
+
+Want to Continue with Load? YES// y  YES
+Loading Distribution...
+
+   C0CRXN DATA 072011 1.0
+
+Globals will now be installed, OK? YES// 
+
+ 
+ Install Started for C0CRXN DATA 072011 1.0 : 
+               Oct 03, 2012@14:43:17
+ 
+ Installing Globals:
+ 
+ ^C0CRXN(176.001)
+               Oct 03, 2012@14:45:15
+ 
+ ^C0CRXN(176.002)
+               Oct 03, 2012@14:45:52
+ 
+ ^C0CRXN(176.003)
+               Oct 03, 2012@14:45:52
+ 
+ Updating KIDS files... 
+ 
+ No link to PACKAGE file
+ 
+ NO Install Message sent to FORUM 
+
+
+ 
+ C0CRXN DATA 072011 1.0 Installed.
+               Oct 03, 2012@14:45:52
+